## scipy 1.12.0

=== doc/Makefile ===
# Makefile for Sphinx documentation

# If `python3` doesn't point to the Python you want to use (with Sphinx installed),
# then you can use, e.g., `make html PYTHON=python3.9` to specify a Python executable
PYTHON = python3

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = LANG=C $(PYTHON) -msphinx

# Environment variables needed for notebooks (see gh-17322):
export SQLALCHEMY_SILENCE_UBER_WARNING?=1
export JUPYTER_PLATFORM_DIRS?=1

FILES=

# Internal variables.
ALLSPHINXOPTS   = -d build/doctrees $(SPHINXOPTS) source

.PHONY: help clean html changes linkcheck dist version-check

#------------------------------------------------------------------------------

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  pickle    to make pickle files (usable by e.g. sphinx-web)"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  changes   to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  clean     to clean all build files/directories"
	@echo "  dist      to make a distribution-ready tree (installing Scipy in venv)"
	@echo "  doc-dist  to make a distribution-ready tree (assuming Scipy is installed)"
	@echo "  upload USERNAME=... RELEASE=... to upload built docs to docs.scipy.org"
	@echo "  show      to show the HTML output"

clean:
	-rm -rf build/* source/reference/generated


#------------------------------------------------------------------------------
# Automated generation of all documents
#------------------------------------------------------------------------------

# Build the current scipy version, and extract docs from it.
# We have to be careful of some issues:
#
# - Everything must be done using the same Python version
# - We must use eggs (otherwise they might override PYTHONPATH on import).
# - Different versions of easy_install install to different directories (!)
#

UPLOAD_DIR=/srv/docs_scipy_org/doc/scipy-$(RELEASE)

SCIPYVER:=$(shell $(PYTHON) -c "import scipy; print(scipy.version.git_revision[:10])" 2>/dev/null)
GITVER ?= $(shell cd ../tools; $(PYTHON) -c "from version_utils import git_version; \
				print(git_version('..')[0][:10])")

version-check:
ifeq "$(GITVER)" "Unknown"
	# @echo sdist build with unlabeled sources
else ifeq ("", "$(SCIPYVER)")
	@echo scipy not found, cannot build documentation without successful \"import scipy\"
	@exit 1
else ifneq ($(SCIPYVER),$(GITVER))
	@echo installed scipy $(SCIPYVER) != current repo git version \'$(GITVER)\'
	@echo use '"make dist"' or '"GITVER=$(SCIPYVER) make $(MAKECMDGOALS) ..."'
	@exit 1
else
	# for testing
	# @echo installed scipy $(SCIPYVER) matches git version $(GITVER); exit 1
endif

dist:
	install -d build
	rm -rf build/env
	$(PYTHON) -mvenv --system-site-packages build/env
	$(CURDIR)/build/env/bin/python -mpip install -r ../doc_requirements.txt
	$(CURDIR)/build/env/bin/python -mpip install ..
	make PYTHON="$(CURDIR)/build/env/bin/python" doc-dist

doc-dist: VERSIONWARNING=-t versionwarning

doc-dist: html
	-test -d build/htmlhelp || make htmlhelp-build
	-rm -rf build/dist
	mkdir -p build/dist
	cp -r build/html/* build/dist
	(cd build/html && zip -9qr ../dist/scipy-html.zip .)
	chmod ug=rwX,o=rX -R build/dist
	find build/dist -type d -print0 | xargs -0r chmod g+s
	cd build/dist && tar czf ../dist.tar.gz *

upload:
	# SSH must be correctly configured for this to work.
	# Assumes that ``make dist`` was already run
	# Example usage: ``make upload USERNAME=rgommers RELEASE=0.17.0``
	ssh $(USERNAME)@new.scipy.org mkdir -p $(UPLOAD_DIR)
	scp build/dist.tar.gz $(USERNAME)@new.scipy.org:$(UPLOAD_DIR)
	ssh $(USERNAME)@new.scipy.org tar xvC $(UPLOAD_DIR) \
	    -zf $(UPLOAD_DIR)/dist.tar.gz
	ssh $(USERNAME)@new.scipy.org mv $(UPLOAD_DIR)/scipy-html.zip \
	    $(UPLOAD_DIR)/scipy-html-$(RELEASE).zip
	ssh $(USERNAME)@new.scipy.org rm $(UPLOAD_DIR)/dist.tar.gz
	ssh $(USERNAME)@new.scipy.org ln -snf scipy-$(RELEASE) /srv/docs_scipy_org/doc/scipy

#------------------------------------------------------------------------------
# Basic Sphinx generation rules for different formats
#------------------------------------------------------------------------------

html: version-check html-build
html-build:
	mkdir -p build/html build/doctrees
	$(SPHINXBUILD) -WT --keep-going $(VERSIONWARNING) -b html $(ALLSPHINXOPTS) build/html $(FILES)

coverage: build version-check
	mkdir -p build/coverage build/doctrees
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) build/coverage $(FILES)
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

changes: version-check
	mkdir -p build/changes build/doctrees
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) build/changes $(FILES)
	@echo
	@echo "The overview file is in build/changes."

linkcheck: version-check
	mkdir -p build/linkcheck build/doctrees
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) build/linkcheck $(FILES)
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in build/linkcheck/output.txt."

show:
	@python -c "import webbrowser; webbrowser.open_new_tab('file://$(PWD)/build/html/index.html')"

=== debian/changelog ===
scipy (1.12.0-2) unstable; urgency=medium

  * hppa: skip test_QRVS_shape_consistency[NumericalInversePolynomial]
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Mon, 03 Jun 2024 18:05:55 +0200

scipy (1.12.0-1exp3) experimental; urgency=medium

  * skip tests with memory or other issues in 32-bit
    - powerpc: test_against_anderson_gumbel_r test_gh12218
    - armel: skip same stats tests as armhf
  * run build tests verbose (-v) on all 32-bit arches

 -- Drew Parsons <dparsons@debian.org>  Thu, 23 May 2024 10:17:16 +0200

scipy (1.12.0-1exp2) experimental; urgency=medium

  * on armhf, i386, hppa, powerpc, skip test_random_state
    test_against_anderson_gumbel_r test_bootstrap_against_R
    test_bootstrap_against_itself_1samp, etc
    to avoid memory failure and random crashes
  * use test verbose flag (-v) on armhf, powerpc
    to identify crashing tests

 -- Drew Parsons <dparsons@debian.org>  Thu, 23 May 2024 01:33:34 +0200

scipy (1.12.0-1exp1) experimental; urgency=medium

  * New upstream release
    - update versioned Build-Depends:
      cython3,
      python3-mesonpy (>= 0.15.0~),
      python3-doit (>= 0.36.0~),
      python3-numpy (>= 1:1.26.0~),
      python3-pythran (>= 0.15.0~)
    - Depends: python3-hypothesis for tests
  * remove redundant debian patch qhull-lfs.patch
    (would need to add to meson.build if still relevant)
  * link to all submodules in submodules/scipy/_lib
  * add Drew Parsons to uploaders

 -- Drew Parsons <dparsons@debian.org>  Tue, 14 May 2024 14:41:42 +0200

=== debian/control ===
Source: scipy
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>,
           Ondrej Certik <ondrej@certik.cz>,
           David Cournapeau <cournape@gmail.com>,
           Varun Hiremath <varun@debian.org>
Section: python
Priority: optional
Build-Depends: cython3,
               debhelper-compat (= 13),
               dh-sequence-python3,
               pybuild-plugin-pyproject,
               gfortran,
               libblas-dev,
               liblapack-dev,
               liblbfgsb-dev,
               libsuitesparse-dev,
               python3-mesonpy (>= 0.15.0~),
               pkgconf,
               python3-all-dev,
               python3-decorator,
               python3-numpy (>= 1:1.26.0~),
               python3-pooch,
               python3-pybind11 (>= 2.10.4~),
               python3-setuptools,
               python3-wheel,
               python3-pythran (>= 0.15.0~),
               python3-pytest,
               python3-doit (>= 0.36.0~) <!nocheck>,
               python3-hypothesis <!nocheck>
Build-Depends-Indep: dvipng,
                     dh-sequence-sphinxdoc,
                     python3-doc,
                     python3-docutils,
                     python3-matplotlib,
                     python3-numpydoc,
                     python3-pydata-sphinx-theme,
                     python3-sphinx,
                     python3-sphinx-design,
                     python3-sphinx-tabs,
                     rdfind,
                     symlinks,
                     texlive-latex-base,
                     texlive-latex-extra
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/python-team/packages/scipy
Vcs-Git: https://salsa.debian.org/python-team/packages/scipy.git
Homepage: https://www.scipy.org/
Rules-Requires-Root: no

Package: python3-scipy
Architecture: any
Multi-Arch: foreign
Depends: python3-decorator,
         python3-numpy (>= 1:1.26.0~),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: g++ | c++-compiler,
            python3-pil
Suggests: python-scipy-doc
Breaks: python3-skbio (<< 0.5.8-3~)
Description: scientific tools for Python 3
 SciPy supplements the popular NumPy module (python-numpy package), gathering a
 variety of high level science and engineering modules together as a single
 package.
 .
 SciPy is a set of Open Source scientific and numeric tools for Python. It
 currently supports special functions, integration, ordinary differential
 equation (ODE) solvers, gradient optimization, genetic algorithms, parallel
 programming tools, an expression-to-C++ compiler for fast execution, and
 others.

Package: python-scipy-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: fonts-open-sans,
         libjs-jquery,
         libjs-mathjax,
         libjs-underscore,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: scientific library for Python - documentation
 SciPy supplements the popular NumPy module (python-numpy package), gathering a
 variety of high level science and engineering modules together as a single
 package.
 .
 SciPy is a set of Open Source scientific and numeric tools for Python. It
 currently supports special functions, integration, ordinary differential
 equation (ODE) solvers, gradient optimization, genetic algorithms, parallel
 programming tools, an expression-to-C++ compiler for fast execution, and
 others.
 .
 This package contains documentation for the SciPy library.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=scipy

include /usr/share/dpkg/architecture.mk

unexport LDFLAGS
export FFLAGS="-fPIC"
export ATLAS=None
export PATH := $(CURDIR)/debian/extra_bin:$(PATH)
export SCIPY_USE_PYTHRAN=0

PY3VERS:= $(shell py3versions -v -s)
PY3_DEFAULT:= $(shell py3versions -dv)
TMPDIR := $(CURDIR)/build/tmp
BASE=$(shell pwd)/debian

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  export NPY_NUM_BUILD_JOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

export SCIPY_USE_PYTHRAN = $(shell if dpkg-query -s python3-pythran >/dev/null 2>/dev/null; then echo 1; else echo 0; fi )

# specify build against generic BLAS/LAPACK. Preferred optimised implementation should be installed
# by the end user, not by the package build.
export PYBUILD_BUILD_ARGS := -Csetup-args=-Dblas=blas -Csetup-args=-Dlapack=lapack

# 32-bit stability degraded in scipy 1.12 with more tests
# getting MemoryError, especially in stats tests
# Run verbose to track more closely.
ifneq (,$(findstring $(DEB_HOST_ARCH_BITS), 32))
    EXTRA_TEST_FLAGS += -v
endif

# stats/tests/test_continuous_basic.py::test_cont_basic[500-200-ncf-arg74] test fails with IntegrationWarning
# https://github.com/scipy/scipy/issues/14519
# test_data (pooch) needs internet or cached data files
SKIP_TEST_LIST += test_cont_basic[500-200-ncf-arg74] test_existence_all test_ascent test_face test_electrocardiogram

# multi-Ellipsis indexing in sparse will be dropped in scipy 1.13
# see https://github.com/scipy/scipy/pull/18541
# it fails tests now so skip and reinstate later for scipy 1.13
SKIP_TEST_LIST += test_multiple_ellipsis_slicing

ifneq (,$(findstring $(DEB_HOST_ARCH), arm64))
    SKIP_TEST_LIST += test_maxiter_worsening[lgmres]
endif

# linalg/tests/test_decomp.py started segfaulting on armel
ifneq (,$(findstring $(DEB_HOST_ARCH), armel))
    SKIP_TEST_LIST += test_decomp test_random_exact test_brunnermunzel_normal_dist test_sparse_dense_divide
    SKIP_TEST_LIST += test_some_code_paths test_gh12218 test_random_state
    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_bootstrap_against_R test_bootstrap_against_itself_1samp
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), armhf))
    SKIP_TEST_LIST += test_gh12218 test_random_state
    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_bootstrap_against_R test_bootstrap_against_itself_1samp
endif

# some tests broken on i386, see https://github.com/scipy/scipy/issues/17839
ifneq (,$(findstring $(DEB_HOST_ARCH), i386))
    SKIP_TEST_LIST += test_find_peaks_exact test_find_peaks_withnoise test_x0_equals_Mb[bicgstab] test_rv_sample
    SKIP_TEST_LIST += test_location_scale[pdf test_examples[True-float64] test_pdf_nolan_samples test_cdf_nolan_samples
    SKIP_TEST_LIST += ellint_rg_xy0_ipp-ellint_rg_xy0 test_hermitian test_random_state
    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_bootstrap_against_R test_bootstrap_against_itself_1samp
endif

# Bug#1017864 test_kolmogorov.py segfaults on i386 (including hurd)
SKIP_KOLMOGOROV_ARCH_LIST := i386 hurd-i386
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_KOLMOGOROV_ARCH_LIST)$(space)))
  SKIP_TEST_LIST += TestSmirnovp
endif

# integrate/_ivp/tests/test_ivp.py fail on mips64el
# see https://github.com/scipy/scipy/issues/16883
# https://github.com/scipy/scipy/issues/17839#issuecomment-1400636840
ifneq (,$(findstring $(DEB_HOST_ARCH), mips64el))
    SKIP_TEST_LIST += test_first_step test_classes test_integrality test_integrator test_double_integrator
    SKIP_TEST_LIST += test_nanminmax
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), mipsel))
    SKIP_TEST_LIST += test_NaN_warnings test_moments_warnings test_fht_special_cases test_integrality test_integrator test_double_integrator
endif

# hppa runs out of memory in test_bootstrap_against_theory
ifneq (,$(findstring $(DEB_HOST_ARCH), hppa))
    SKIP_TEST_LIST += test_nodata test_cont_basic[500-200-semicircular-arg89] test_bootstrap_against_theory test_distance_transform_cdt05
    SKIP_TEST_LIST += test_onenormest_linear_operator test_against_anderson_gumbel_r test_gh12218
    SKIP_TEST_LIST += test_roots_hermite_asy test_bootstrap_against_R bootstrap_against_itself test_against_f_oneway
    SKIP_TEST_LIST += test_QRVS_shape_consistency[1-d_out1-1-size_out1-qrng1-NumericalInversePolynomial]
endif

# powerpc: failures in stats/tests/test_stats.py: overflow encountered in _hypergeom_*
ifneq (,$(findstring $(DEB_HOST_ARCH), powerpc))
    SKIP_TEST_LIST += test_hypergeom_cdf test_hypergeom_sf test_nch_hypergeom test_precision test_precise
    SKIP_TEST_LIST += test_less_greater test_maxiter_worsening[lgmres] test_distance_transform_cdt05
    SKIP_TEST_LIST += test_roots_hermite_asy test_bootstrap_against_R bootstrap_against_itself test_against_f_oneway
    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_gh12218
endif

# test_atol[bicg] only just misses tolerance on s390x, but the design of the test makes it difficult to workaround,
# so skip. See https://github.com/scipy/scipy/issues/17839#issuecomment-1399477182
ifneq (,$(findstring $(DEB_HOST_ARCH), s390x))
    SKIP_TEST_LIST += test_maxiter_worsening test_atol[bicg] test_distance_transform_cdt05
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), hurd-i386))
    SKIP_TEST_LIST += test_mip1 test_find_peaks_exact test_find_peaks_withnoise test_examples[True-float64] test_rv_sample test_location_scale[pdf
    SKIP_TEST_LIST += test_pdf_nolan_samples[pct_range0-alpha_range0-beta_range0] ellint_rg_xy0_ipp-ellint_rg_xy0
    SKIP_TEST_LIST += test_logpdf_pdf_consistency test_gh12218 test_ttest_many_dims
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), ia64))
    EXTRA_TEST_FLAGS += -v
    SKIP_TEST_LIST += test_maxiter_worsening[lgmres] test_examples[True-complex64]
endif

# https://github.com/scipy/scipy/issues/17839#issuecomment-1399478853
ifneq (,$(findstring $(DEB_HOST_ARCH), ppc64))
    SKIP_TEST_LIST += test_precond_dummy test_maxiter_worsening[lgmres] test_distance_transform_cdt05
endif

# https://github.com/scipy/scipy/issues/17839#issuecomment-1401780853
ifneq (,$(findstring $(DEB_HOST_ARCH), riscv64))
    SKIP_TEST_LIST += test_maxiter_worsening[lgmres] test_milp_timeout_16545
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), sparc64))
    SKIP_TEST_LIST += test_distance_transform_cdt05 test_milp_timeout_16545
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), x32))
    SKIP_TEST_LIST += test_input_validation test_basic test_sign test_flexible_input \
	test_perm_discrepancy test_integers_nd test_0dim test_0sample test_1sample \
	test_bounds test_random_generator test_sample test_continuing \
	test_svd_random_state_2 ellint_rg_xy0_ipp-ellint_rg_xy0 test_reset
endif

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_auto_clean:
	rm -rf build .pybuild
	-find $(CURDIR) -name __pycache__ -type d -exec rm -rf {} +
	-rm -rf doc/source/fontList*
	-rm -rf doc/source/reference/generated
	-rm -rf doc/build

execute_before_dh_clean:
	# make sure symlinks to submodules are cleaned up or empty directories from tarball are removed
	rm -rf doc/source/_static/scipy-mathjax
	rm -rf scipy/sparse/linalg/_propack/PROPACK
	for submod_lib in submodules/scipy/_lib/*; do \
	  submod_libname=`basename $$submod_lib`; \
	  rm -rf scipy/_lib/$$submod_libname; \
	done

execute_before_dh_auto_configure:
	echo "Symlink to submodules"
	ln -sf ../../../submodules/doc/source/_static/scipy-mathjax		doc/source/_static/scipy-mathjax
	ln -sf ../../../../submodules/scipy/sparse/linalg/_propack/PROPACK	scipy/sparse/linalg/_propack/PROPACK
	for submod_lib in submodules/scipy/_lib/*; do \
	  submod_libname=`basename $$submod_lib`; \
	  ln -sf ../../$$submod_lib scipy/_lib/$$submod_libname; \
	done
	echo "Building scipy with SCIPY_USE_PYTHRAN=$(SCIPY_USE_PYTHRAN)"

execute_before_dh_installdocs-indep:
	(export MPLCONFIGDIR=. ; \
	PYLIBPATH=`pybuild --print build_dir -p$(PY3_DEFAULT) | awk '{print $$3}'`; \
	echo "building docs using PYLIBPATH=$$PYLIBPATH"; \

## scipy 1.13.1

=== debian/changelog ===
scipy (1.13.1-5ubuntu1) plucky; urgency=medium

  * Ignore test results for first build

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 15 Nov 2024 00:16:22 +0000

scipy (1.13.1-5build1) plucky; urgency=medium

  * No-change rebuild to add support for Python 3.13.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Nov 2024 10:53:34 +0100

scipy (1.13.1-5) unstable; urgency=medium

  * skip more failing tests
    - mips64el: test_2x2_input test_nx2x2_input
      (from linalg test_matfuncs.py::TestExpM)
    - hppa: more test_QRVS_shape_consistency variants
    - x32: TestKSTwoSamples.test_gh12218 (gets MemoryError)

 -- Drew Parsons <dparsons@debian.org>  Sat, 24 Aug 2024 10:24:03 +0200

scipy (1.13.1-4) unstable; urgency=medium

  * revert python3-scipy back to Multi-Arch: no.
    The arch is recorded inside some installed (plain text) files
    e.g. scipy-*.dist-info/WHEEL, scipy/__config__.py
    Closes: #1078977.
  * skip failing tests
    - alpha: test_read_over64bit_integer_sparse
    - hppa: test_svd_gesdd_nofegfault

 -- Drew Parsons <dparsons@debian.org>  Thu, 22 Aug 2024 01:07:47 +0200

scipy (1.13.1-3) unstable; urgency=medium

  * alpha: skip test_read_over64bit_integer_dense
  * hppa: skip next test_QRVS_shape_consistency (qrng2)
  * drop mipsel, ia64 test skips. Architectures no longer supported.

 -- Drew Parsons <dparsons@debian.org>  Sun, 11 Aug 2024 18:19:53 +0200

scipy (1.13.1-2) unstable; urgency=medium

  * hppa: skip another test_QRVS_shape_consistency test case
    (stats test_sampling.py)

 -- Drew Parsons <dparsons@debian.org>  Wed, 31 Jul 2024 18:43:22 +0200

scipy (1.13.1-1exp15) experimental; urgency=medium

  * debian patch quadpack_C_PR21201.patch applies upstream PR#21201 to
    refactor quadpack in C instead of fortran. Closes: #1074318.

 -- Drew Parsons <dparsons@debian.org>  Tue, 23 Jul 2024 15:31:31 +0200

scipy (1.13.1-1exp14) experimental; urgency=medium

  * riscv64 hppa sparc64: skip test_nan_inputs[airye] from special

 -- Drew Parsons <dparsons@debian.org>  Tue, 09 Jul 2024 00:22:38 +0200

scipy (1.13.1-1exp13) experimental; urgency=medium

  * riscv64 hppa sparc64: skip tests in signal test_cont2discrete.py
    and elsewhere:
    test_random_matrices_and_powers test_2x2_input test_nx2x2_input
    test_zoh test_foh test_transferfunction test_zerospolesgain
    test_discrete_approx test_simo_tf test_multioutput
    TestC2dLti TestC2dInvariants TestStep
    test_second_order test_integrator test_double_integrator
    test_jordan_block test_array_like test_operators test_expm

 -- Drew Parsons <dparsons@debian.org>  Mon, 08 Jul 2024 10:24:38 +0200

scipy (1.13.1-1exp12) experimental; urgency=medium

  * riscv64 hppa sparc64: skip test_multioutput (signal cont2discrete)

 -- Drew Parsons <dparsons@debian.org>  Sat, 06 Jul 2024 23:04:18 +0200

scipy (1.13.1-1exp11) experimental; urgency=medium

  * riscv64 hppa sparc64: skip test_simo_tf
    (signal test_cont2discrete.py)

 -- Drew Parsons <dparsons@debian.org>  Fri, 05 Jul 2024 00:07:28 +0200

scipy (1.13.1-1exp10) experimental; urgency=medium

  * riscv64 hppa sparc64: skip test_zerospolesgain test_discrete_approx
    (from signal test_cont2discrete.py)

 -- Drew Parsons <dparsons@debian.org>  Wed, 03 Jul 2024 18:42:09 +0200

scipy (1.13.1-1exp9) experimental; urgency=medium

  * riscv64 hppa sparc64: skip test_transferfunction

 -- Drew Parsons <dparsons@debian.org>  Tue, 02 Jul 2024 09:58:12 +0200

scipy (1.13.1-1exp8) experimental; urgency=medium

  * make docs with HOME=/tmp (cf. matplotlib doc build) to avoid error:
    '/sbuild-nonexistent' is not a writable location
  * riscv64 hppa sparc64: skip test_foh

 -- Drew Parsons <dparsons@debian.org>  Mon, 01 Jul 2024 11:07:05 +0200

scipy (1.13.1-1exp7) experimental; urgency=medium

  * riscv64 hppa sparc64: skip test_zoh (signal test)
  * use intersphinx to link docs
    - update debian patch manage_docs.patch
    - drop debian patch 0018-Drop-intersphinx.patch
    - Build-Depends-Indep: python-matplotlib-doc, python-numpy-doc,
      python-statsmodels-doc <!nodoc>
  * build docs using JUPYTER_PLATFORM_DIRS=1
    (for jupyter_cache used by myst_nb)

 -- Drew Parsons <dparsons@debian.org>  Wed, 19 Jun 2024 11:05:59 +0200

scipy (1.13.1-1exp6) experimental; urgency=medium

  * skip TestExp (linalg test_matfuncs.py) on riscv64 hppa sparc64

 -- Drew Parsons <dparsons@debian.org>  Fri, 14 Jun 2024 17:11:04 +0200

scipy (1.13.1-1exp5) experimental; urgency=medium

  * add mips64el to the verbose test list
  * skip failing tests
    - riscv64 hppa sparc64: test_nx2x2_input
      (from linalg test_matfuncs.py TestExpM)
    - powerpc: test_svd_gesdd_nofegfault (linalg test_decomp.py)

 -- Drew Parsons <dparsons@debian.org>  Wed, 12 Jun 2024 10:40:56 +0200

scipy (1.13.1-1exp4) experimental; urgency=medium

  * skip test_random_matrices_and_powers and test_2x2_input
    on riscv64 hppa sparc64

 -- Drew Parsons <dparsons@debian.org>  Sun, 09 Jun 2024 22:58:37 +0200

scipy (1.13.1-1exp3) experimental; urgency=medium

  * add mips64el to the TestLogM skip list
  * riscv64 and sparc64 time out. Run verbose tests to see where they
    got stuck.
  * hppa: skip test_random_matrices_and_powers

 -- Drew Parsons <dparsons@debian.org>  Fri, 07 Jun 2024 22:59:54 +0200

scipy (1.13.1-1exp2) experimental; urgency=medium

  * i386: skip test_svd_gesdd_nofegfault (MemoryError)
  * skip linalg test_matfuncs.py::TestLogM on failing arches,
    riscv64 hppa sparc64
  * debian patch test_singular_tol_PR20914.patch applies upstream
    PR#20914 to relax tolerance enabling linalg test_singular to pass
    against generic (netlib) BLAS.

 -- Drew Parsons <dparsons@debian.org>  Thu, 06 Jun 2024 22:28:40 +0200

scipy (1.13.1-1exp1) experimental; urgency=medium

  * New upstream release
    - Build-Depends: python3-pybind11 (>= 2.12.0~)
    - debian/copyright: drop pocketfft_hdronly.h
  * drop deprecated debian patch docs_privacy.patch


=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: scipy
-Maintainer: Debian Python Team <team+python@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: Drew Parsons <dparsons@debian.org>,
            Ondrej Certik <ondrej@certik.cz>,
            David Cournapeau <cournape@gmail.com>,
@@ -21,7 +22,7 @@
                python3-decorator,
                python3-numpy (>= 1:1.26.0~),
                python3-pooch,
-               python3-pybind11 (>= 2.10.4~),
+               python3-pybind11 (>= 2.12.0~),
                python3-setuptools,
                python3-wheel,
                python3-pythran (>= 0.15.0~),
@@ -30,14 +31,18 @@
                python3-hypothesis <!nocheck>
 Build-Depends-Indep: dvipng,
                      dh-sequence-sphinxdoc,
-                     python3-doc,
+                     python3-doc <!nodoc>,
                      python3-docutils,
                      python3-matplotlib,
-                     python3-numpydoc,
+                     python-matplotlib-doc <!nodoc>,
+                     python3-myst-nb <!nodoc>,
+                     python-numpy-doc <!nodoc>,
+                     python3-numpydoc <!nodoc>,
                      python3-pydata-sphinx-theme,
                      python3-sphinx,
                      python3-sphinx-design,
                      python3-sphinx-tabs,
+                     python-statsmodels-doc <!nodoc>,
                      rdfind,
                      symlinks,
                      texlive-latex-base,
@@ -50,7 +55,7 @@
 
 Package: python3-scipy
 Architecture: any
-Multi-Arch: foreign
+Multi-Arch: no
 Depends: python3-decorator,
          python3-numpy (>= 1:1.26.0~),
          ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=scipy

include /usr/share/dpkg/architecture.mk

unexport LDFLAGS
export FFLAGS="-fPIC"
export ATLAS=None
export PATH := $(CURDIR)/debian/extra_bin:$(PATH)
export SCIPY_USE_PYTHRAN=0

PY3VERS:= $(shell py3versions -v -s)
PY3_DEFAULT:= $(shell py3versions -dv)
TMPDIR := $(CURDIR)/build/tmp
BASE=$(shell pwd)/debian

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  export NPY_NUM_BUILD_JOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

export SCIPY_USE_PYTHRAN = $(shell if dpkg-query -s python3-pythran >/dev/null 2>/dev/null; then echo 1; else echo 0; fi )

# specify build against generic BLAS/LAPACK. Preferred optimised implementation should be installed
# by the end user, not by the package build.
export PYBUILD_BUILD_ARGS := -Csetup-args=-Dblas=blas -Csetup-args=-Dlapack=lapack

# some arches time out. Run verbose to see where they got stuck.
VERBOSE_ARCH_LIST := mips64el riscv64 sparc64

# 32-bit stability degraded in scipy 1.12 with more tests
# getting MemoryError, especially in stats tests
# Run verbose to track more closely.
ifneq (,$(findstring $(DEB_HOST_ARCH_BITS), 32))
    VERBOSE_ARCH_LIST += $(DEB_HOST_ARCH)
endif

ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(VERBOSE_ARCH_LIST)$(space)))
    EXTRA_TEST_FLAGS += -v
endif

# stats/tests/test_continuous_basic.py::test_cont_basic[500-200-ncf-arg74] test fails with IntegrationWarning
# https://github.com/scipy/scipy/issues/14519
# test_data (pooch) needs internet or cached data files
SKIP_TEST_LIST += test_cont_basic[500-200-ncf-arg74] test_existence_all test_ascent test_face test_electrocardiogram

# multi-Ellipsis indexing in sparse will be dropped in scipy 1.13
# see https://github.com/scipy/scipy/pull/18541
# it fails tests now so skip and reinstate later for scipy 1.13
SKIP_TEST_LIST += test_multiple_ellipsis_slicing

ifneq (,$(findstring $(DEB_HOST_ARCH), arm64))
    SKIP_TEST_LIST += test_maxiter_worsening[lgmres]
endif

# linalg/tests/test_decomp.py started segfaulting on armel
ifneq (,$(findstring $(DEB_HOST_ARCH), armel))
    SKIP_TEST_LIST += test_decomp test_random_exact test_brunnermunzel_normal_dist test_sparse_dense_divide
    SKIP_TEST_LIST += test_some_code_paths test_gh12218 test_random_state
    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_bootstrap_against_R test_bootstrap_against_itself_1samp
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), armhf))
    SKIP_TEST_LIST += test_gh12218 test_random_state
    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_bootstrap_against_R test_bootstrap_against_itself_1samp
endif

# some tests broken on i386, see https://github.com/scipy/scipy/issues/17839
ifneq (,$(findstring $(DEB_HOST_ARCH), i386))
    SKIP_TEST_LIST += test_find_peaks_exact test_find_peaks_withnoise test_x0_equals_Mb[bicgstab] test_rv_sample
    SKIP_TEST_LIST += test_location_scale[pdf test_examples[True-float64] test_pdf_nolan_samples test_cdf_nolan_samples
    SKIP_TEST_LIST += ellint_rg_xy0_ipp-ellint_rg_xy0 test_hermitian test_random_state
    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_bootstrap_against_R test_bootstrap_against_itself_1samp
    SKIP_TEST_LIST += test_svd_gesdd_nofegfault
endif

# integrate/_ivp/tests/test_ivp.py fail on mips64el
# see https://github.com/scipy/scipy/issues/16883
# https://github.com/scipy/scipy/issues/17839#issuecomment-1400636840
ifneq (,$(findstring $(DEB_HOST_ARCH), mips64el))
    SKIP_TEST_LIST += test_first_step test_classes test_integrality test_integrator test_double_integrator
    SKIP_TEST_LIST += test_nanminmax TestLogM test_2x2_input test_nx2x2_input
endif

# https://github.com/scipy/scipy/issues/17839#issuecomment-1401780853
ifneq (,$(findstring $(DEB_HOST_ARCH), riscv64))
    SKIP_TEST_LIST += test_maxiter_worsening[lgmres] test_milp_timeout_16545
endif

# test_atol[bicg] only just misses tolerance on s390x, but the design of the test makes it difficult to workaround,
# so skip. See https://github.com/scipy/scipy/issues/17839#issuecomment-1399477182
ifneq (,$(findstring $(DEB_HOST_ARCH), s390x))
    SKIP_TEST_LIST += test_maxiter_worsening test_atol[bicg] test_distance_transform_cdt05
endif

# Bug#1017864 test_kolmogorov.py segfaults on i386 (including hurd)
SKIP_KOLMOGOROV_ARCH_LIST := i386 hurd-i386
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_KOLMOGOROV_ARCH_LIST)$(space)))
    SKIP_TEST_LIST += TestSmirnovp
endif

# some tests in linalg test_matfuncs.py fail on several arches
# in particular riscv64 hppa sparc64 share many common test failure
SKIP_TestLogM_ARCH_LIST := riscv64 hppa sparc64
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_TestLogM_ARCH_LIST)$(space)))
    SKIP_TEST_LIST += TestLogM TestExp test_expm
    SKIP_TEST_LIST += test_random_matrices_and_powers test_2x2_input test_nx2x2_input
    SKIP_TEST_LIST += test_zoh test_foh test_transferfunction
    SKIP_TEST_LIST += test_zerospolesgain test_discrete_approx test_simo_tf test_multioutput
    SKIP_TEST_LIST += test_simo_tf test_multioutput TestC2dLti TestC2dInvariants
    SKIP_TEST_LIST += test_second_order test_integrator test_double_integrator
    SKIP_TEST_LIST += test_jordan_block test_array_like TestStep test_operators
    SKIP_TEST_LIST += test_nan_inputs[airye]
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), alpha))
    SKIP_TEST_LIST += test_read_over64bit_integer_dense test_read_over64bit_integer_sparse
endif

# hppa runs out of memory in test_bootstrap_against_theory
ifneq (,$(findstring $(DEB_HOST_ARCH), hppa))
    SKIP_TEST_LIST += test_nodata test_cont_basic[500-200-semicircular-arg89] test_bootstrap_against_theory test_distance_transform_cdt05
    SKIP_TEST_LIST += test_onenormest_linear_operator test_against_anderson_gumbel_r test_gh12218
    SKIP_TEST_LIST += test_roots_hermite_asy test_bootstrap_against_R bootstrap_against_itself test_against_f_oneway
    SKIP_TEST_LIST += test_QRVS_shape_consistency[1-d_out1-1-size_out1-qrng1-NumericalInversePolynomial]
    SKIP_TEST_LIST += test_QRVS_shape_consistency[None-d_out0-size_in4-size_out4-None-NumericalInversePolynomial]
    SKIP_TEST_LIST += test_QRVS_shape_consistency[None-d_out0-size_in4-size_out4-qrng1-NumericalInversePolynomial]
    SKIP_TEST_LIST += test_QRVS_shape_consistency[None-d_out0-size_in4-size_out4-qrng2-NumericalInversePolynomial]
    SKIP_TEST_LIST += test_QRVS_shape_consistency[3-d_out2-None-size_out0-None-NumericalInversePolynomial]
    SKIP_TEST_LIST += test_svd_gesdd_nofegfault
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), hurd-i386))
    SKIP_TEST_LIST += test_mip1 test_find_peaks_exact test_find_peaks_withnoise test_examples[True-float64] test_rv_sample test_location_scale[pdf
    SKIP_TEST_LIST += test_pdf_nolan_samples[pct_range0-alpha_range0-beta_range0] ellint_rg_xy0_ipp-ellint_rg_xy0
    SKIP_TEST_LIST += test_logpdf_pdf_consistency test_gh12218 test_ttest_many_dims
endif

# powerpc: failures in stats/tests/test_stats.py: overflow encountered in _hypergeom_*
ifneq (,$(findstring $(DEB_HOST_ARCH), powerpc))
    SKIP_TEST_LIST += test_hypergeom_cdf test_hypergeom_sf test_nch_hypergeom test_precision test_precise
    SKIP_TEST_LIST += test_less_greater test_maxiter_worsening[lgmres] test_distance_transform_cdt05
    SKIP_TEST_LIST += test_roots_hermite_asy test_bootstrap_against_R bootstrap_against_itself test_against_f_oneway
    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_gh12218 test_svd_gesdd_nofegfault
endif

# https://github.com/scipy/scipy/issues/17839#issuecomment-1399478853
ifneq (,$(findstring $(DEB_HOST_ARCH), ppc64))
    SKIP_TEST_LIST += test_precond_dummy test_maxiter_worsening[lgmres] test_distance_transform_cdt05
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), sparc64))
    SKIP_TEST_LIST += test_distance_transform_cdt05 test_milp_timeout_16545
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), x32))
    SKIP_TEST_LIST += test_input_validation test_basic test_sign test_flexible_input \

## scipy 1.14.0

=== debian/changelog ===
scipy (1.14.0-1exp5) experimental; urgency=medium

  * mip64el: skip flakey TestExpmFrechet (linalg test_matfuncs.py)
  * hppa: skip more test_QRVS_shape_consistency

 -- Drew Parsons <dparsons@debian.org>  Mon, 26 Aug 2024 17:07:11 +0200

scipy (1.14.0-1exp4) experimental; urgency=medium

  * mips64el: skip failing variants of test_axis_nan_policy_axis_is_None
    (stats test_axis_nan_policy.py)
  * add hppa to the NEEDS_NUMPY2 list (skip test_cython)

 -- Drew Parsons <dparsons@debian.org>  Mon, 26 Aug 2024 09:23:15 +0200

scipy (1.14.0-1exp3) experimental; urgency=medium

  * run dh_python3 with --no-ext-rename instead of manipulating
    libsf_error_state.so manually. mesonpy already instructs cython to
    build python extensions with arch labels, so don't need extension
    renaming from dh_python3. See Bug#1079496.
  * update test skips
    - mips64el: skip test_random_matrices_and_powers
    - x32: reenable TestKSTwoSamples.test_gh12218. The dot was not
      recognised (must be test_gh12218 alone), but the test is
      naturally skipped with scipy 1.14 anyway.
    - add alpha to the test_cython (Numpy 2) skip list

 -- Drew Parsons <dparsons@debian.org>  Sun, 25 Aug 2024 10:05:09 +0200

scipy (1.14.0-1exp2) experimental; urgency=medium

  * debian/rules: shift scipy/special/libsf_error_state.so to
    libsf_error_state while running dh_python3. It is a "normal"
    shared library not a python extension, but dh_python3 would rename
    it as if it were a python extension, causing runtime failure
    finding the library. dh_python3 -X does not exclude that (see
    Bug#1079496). Closes: #1078540.
  * mips64el powerpc ppc64: skip test_cython (special test_extending)
    Needs complex type changes from numpy 2 to pass.
    See https://github.com/scipy/scipy/issues/21393
  * skip more failing tests
    - mips64el: test_2x2_input (linalg test_matfuncs.py::TestExpM)
    - hppa: more test_QRVS_shape_consistency variants
    - x32: TestKSTwoSamples.test_gh12218 (gets MemoryError)

 -- Drew Parsons <dparsons@debian.org>  Sat, 24 Aug 2024 02:16:41 +0200

scipy (1.14.0-1exp1) experimental; urgency=medium

  * New upstream release
    - applies debian patch test_singular_tol_PR20914.patch
    - special/cephes moved to special/special/cephes
  * debian patch fix_scipydoc_directive_PR20976.patch applies upstream
    PR#20976 to fix doc build (needs StringList not ViewList)
  * update debian patch manage_docs.patch
    (theme-switcher is not available)

 -- Drew Parsons <dparsons@debian.org>  Mon, 12 Aug 2024 00:42:15 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: scipy
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Python Team <team+python@tracker.debian.org>
+Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: Drew Parsons <dparsons@debian.org>,
            Ondrej Certik <ondrej@certik.cz>,
            David Cournapeau <cournape@gmail.com>,

=== debian/rules ===
--- 
+++ 
@@ -79,7 +79,11 @@
 # https://github.com/scipy/scipy/issues/17839#issuecomment-1400636840
 ifneq (,$(findstring $(DEB_HOST_ARCH), mips64el))
     SKIP_TEST_LIST += test_first_step test_classes test_integrality test_integrator test_double_integrator
-    SKIP_TEST_LIST += test_nanminmax TestLogM test_2x2_input test_nx2x2_input
+    SKIP_TEST_LIST += test_nanminmax TestLogM TestExpmFrechet
+    SKIP_TEST_LIST += test_2x2_input test_nx2x2_input test_random_matrices_and_powers
+    SKIP_TEST_LIST += test_axis_nan_policy_axis_is_None[all_nans-propagate-ttest_ci
+    SKIP_TEST_LIST += test_axis_nan_policy_axis_is_None[mixed-propagate-iqr
+    SKIP_TEST_LIST += test_axis_nan_policy_axis_is_None[mixed-propagate-ttest_ci
 endif
 
 # https://github.com/scipy/scipy/issues/17839#issuecomment-1401780853
@@ -113,6 +117,15 @@
     SKIP_TEST_LIST += test_nan_inputs[airye]
 endif
 
+# some archs fail test_cython (special test_extending) with numpy 1.26
+# but will pass with numpy 2 due to complex type changes
+# see https://github.com/scipy/scipy/issues/21393
+SKIP_NEEDS_NUMPY2_ARCH_LIST := mips64el alpha hppa powerpc ppc64
+ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_NEEDS_NUMPY2_ARCH_LIST)$(space)))
+    SKIP_TEST_LIST += test_cython
+endif
+
+
 ifneq (,$(findstring $(DEB_HOST_ARCH), alpha))
     SKIP_TEST_LIST += test_read_over64bit_integer_dense test_read_over64bit_integer_sparse
 endif
@@ -127,6 +140,7 @@
     SKIP_TEST_LIST += test_QRVS_shape_consistency[None-d_out0-size_in4-size_out4-qrng1-NumericalInversePolynomial]
     SKIP_TEST_LIST += test_QRVS_shape_consistency[None-d_out0-size_in4-size_out4-qrng2-NumericalInversePolynomial]
     SKIP_TEST_LIST += test_QRVS_shape_consistency[3-d_out2-None-size_out0-None-NumericalInversePolynomial]
+    SKIP_TEST_LIST += test_QRVS_shape_consistency[1-d_out1-size_in4-size_out4-qrng2-NumericalInversePolynomial]
     SKIP_TEST_LIST += test_svd_gesdd_nofegfault
 endif
 
@@ -138,20 +152,3 @@
 
 # powerpc: failures in stats/tests/test_stats.py: overflow encountered in _hypergeom_*
 ifneq (,$(findstring $(DEB_HOST_ARCH), powerpc))
-    SKIP_TEST_LIST += test_hypergeom_cdf test_hypergeom_sf test_nch_hypergeom test_precision test_precise
-    SKIP_TEST_LIST += test_less_greater test_maxiter_worsening[lgmres] test_distance_transform_cdt05
-    SKIP_TEST_LIST += test_roots_hermite_asy test_bootstrap_against_R bootstrap_against_itself test_against_f_oneway
-    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_gh12218 test_svd_gesdd_nofegfault
-endif
-
-# https://github.com/scipy/scipy/issues/17839#issuecomment-1399478853
-ifneq (,$(findstring $(DEB_HOST_ARCH), ppc64))
-    SKIP_TEST_LIST += test_precond_dummy test_maxiter_worsening[lgmres] test_distance_transform_cdt05
-endif
-
-ifneq (,$(findstring $(DEB_HOST_ARCH), sparc64))
-    SKIP_TEST_LIST += test_distance_transform_cdt05 test_milp_timeout_16545
-endif
-
-ifneq (,$(findstring $(DEB_HOST_ARCH), x32))
-    SKIP_TEST_LIST += test_input_validation test_basic test_sign test_flexible_input \
